freedombone-image-customise 50KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465666768697071727374757677787980818283848586878889909192939495969798991001011021031041051061071081091101111121131141151161171181191201211221231241251261271281291301311321331341351361371381391401411421431441451461471481491501511521531541551561571581591601611621631641651661671681691701711721731741751761771781791801811821831841851861871881891901911921931941951961971981992002012022032042052062072082092102112122132142152162172182192202212222232242252262272282292302312322332342352362372382392402412422432442452462472482492502512522532542552562572582592602612622632642652662672682692702712722732742752762772782792802812822832842852862872882892902912922932942952962972982993003013023033043053063073083093103113123133143153163173183193203213223233243253263273283293303313323333343353363373383393403413423433443453463473483493503513523533543553563573583593603613623633643653663673683693703713723733743753763773783793803813823833843853863873883893903913923933943953963973983994004014024034044054064074084094104114124134144154164174184194204214224234244254264274284294304314324334344354364374384394404414424434444454464474484494504514524534544554564574584594604614624634644654664674684694704714724734744754764774784794804814824834844854864874884894904914924934944954964974984995005015025035045055065075085095105115125135145155165175185195205215225235245255265275285295305315325335345355365375385395405415425435445455465475485495505515525535545555565575585595605615625635645655665675685695705715725735745755765775785795805815825835845855865875885895905915925935945955965975985996006016026036046056066076086096106116126136146156166176186196206216226236246256266276286296306316326336346356366376386396406416426436446456466476486496506516526536546556566576586596606616626636646656666676686696706716726736746756766776786796806816826836846856866876886896906916926936946956966976986997007017027037047057067077087097107117127137147157167177187197207217227237247257267277287297307317327337347357367377387397407417427437447457467477487497507517527537547557567577587597607617627637647657667677687697707717727737747757767777787797807817827837847857867877887897907917927937947957967977987998008018028038048058068078088098108118128138148158168178188198208218228238248258268278288298308318328338348358368378388398408418428438448458468478488498508518528538548558568578588598608618628638648658668678688698708718728738748758768778788798808818828838848858868878888898908918928938948958968978988999009019029039049059069079089099109119129139149159169179189199209219229239249259269279289299309319329339349359369379389399409419429439449459469479489499509519529539549559569579589599609619629639649659669679689699709719729739749759769779789799809819829839849859869879889899909919929939949959969979989991000100110021003100410051006100710081009101010111012101310141015101610171018101910201021102210231024102510261027102810291030103110321033103410351036103710381039104010411042104310441045104610471048104910501051105210531054105510561057105810591060106110621063106410651066106710681069107010711072107310741075107610771078107910801081108210831084108510861087108810891090109110921093109410951096109710981099110011011102110311041105110611071108110911101111111211131114111511161117111811191120112111221123112411251126112711281129113011311132113311341135113611371138113911401141114211431144114511461147114811491150115111521153115411551156115711581159116011611162116311641165116611671168116911701171117211731174117511761177117811791180118111821183118411851186118711881189119011911192119311941195119611971198119912001201120212031204120512061207120812091210121112121213121412151216121712181219122012211222122312241225122612271228122912301231123212331234123512361237123812391240124112421243124412451246124712481249125012511252125312541255125612571258125912601261126212631264126512661267126812691270127112721273127412751276127712781279128012811282128312841285128612871288128912901291129212931294129512961297129812991300130113021303130413051306130713081309131013111312131313141315131613171318131913201321132213231324132513261327132813291330133113321333133413351336
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # Based on bin/freedombox-customize from freedom-maker
  12. #
  13. # License
  14. # =======
  15. #
  16. # This program is free software: you can redistribute it and/or modify
  17. # it under the terms of the GNU Affero General Public License as published by
  18. # the Free Software Foundation, either version 3 of the License, or
  19. # (at your option) any later version.
  20. #
  21. # This program is distributed in the hope that it will be useful,
  22. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  23. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  24. # GNU Affero General Public License for more details.
  25. #
  26. # You should have received a copy of the GNU Affero General Public License
  27. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  28. set -e
  29. set -x
  30. PROJECT_NAME='freedombone'
  31. INSTALL_DIR=/root/build
  32. COMPLETION_FILE=$HOME/${PROJECT_NAME}-completed.txt
  33. PROJECT_REPO="https://github.com/bashrc/${PROJECT_NAME}"
  34. VARIANT='full'
  35. # username created by default within a debian image
  36. GENERIC_IMAGE_USERNAME='fbone'
  37. export TEXTDOMAIN=${PROJECT_NAME}-image-customise
  38. export TEXTDOMAINDIR="/usr/share/locale"
  39. # Whether to minimise the number of decisions during interactive install
  40. MINIMAL_INSTALL="yes"
  41. MY_USERNAME='debian'
  42. MY_PASSWORD="${PROJECT_NAME}"
  43. # Minimum number of characters in a password
  44. MINIMUM_PASSWORD_LENGTH=10
  45. # IP address of the router (gateway)
  46. ROUTER_IP_ADDRESS="192.168.1.254"
  47. # The fixed IP address of the Beaglebone Black on your local network
  48. BOX_IP_ADDRESS="192.168.1.55"
  49. # DNS
  50. NAMESERVER1='213.73.91.35'
  51. NAMESERVER2='85.214.20.141'
  52. # optional configuration file containing freedombone settings
  53. CONFIG_FILENAME=
  54. # Optional ssh public key to allow
  55. SSH_PUBKEY="no"
  56. # Whether this is a generic image for mass redistribution on the interwebs
  57. GENERIC_IMAGE="no"
  58. # default SSH port
  59. SSH_PORT=2222
  60. # for mesh installs
  61. TRACKER_PORT=6969
  62. # Whether sites are accessible only within a Tor browser
  63. ONION_ONLY="no"
  64. # Whether to only install debian and nothing else
  65. DEBIAN_INSTALL_ONLY="no"
  66. # wifi settings
  67. WIFI_INTERFACE='wlan0'
  68. WIFI_SSID=
  69. WIFI_TYPE='wpa2-psk'
  70. WIFI_PASSPHRASE=
  71. WIFI_HOTSPOT='no'
  72. WIFI_NETWORKS_FILE=~/${PROJECT_NAME}-wifi.cfg
  73. # Whether to install non-free wifi drivers for the mesh client
  74. INSECURE='no'
  75. # optional desktop background image for mesh
  76. MESH_DESKTOP_BACKGROUND_IMAGE=/usr/local/share/${PROJECT_NAME}_mesh_background.png
  77. enable_eatmydata_override() {
  78. chroot $rootdir apt-get install --no-install-recommends -y eatmydata
  79. if [ -x $rootdir/usr/bin/eatmydata ] && \
  80. [ ! -f $rootdir/etc/apt/apt.conf.d/95debian-edu-install-dpkg-eatmydata ]; then
  81. echo $"info: Adding apt config to call dpkg via eatmydata"
  82. printf "#!/bin/sh\nexec eatmydata dpkg \"\$@\"\n" \
  83. > $rootdir/var/tmp/dpkg-eatmydata
  84. chmod 755 $rootdir/var/tmp/dpkg-eatmydata
  85. cat > $rootdir/etc/apt/apt.conf.d/95debian-edu-install-dpkg-eatmydata <<EOF
  86. Dir::Bin::dpkg "/var/tmp/dpkg-eatmydata";
  87. EOF
  88. else
  89. echo $"error: unable to find /usr/bin/eatmydata after installing the eatmydata package"
  90. fi
  91. }
  92. disable_eatmydata_override() {
  93. for override in \
  94. /etc/apt/apt.conf.d/95debian-edu-install-dpkg-eatmydata \
  95. /var/tmp/dpkg-eatmydata ; do
  96. echo $"info: Removing apt config to call dpkg via eatmydata"
  97. if [ -f $rootdir$override ] ; then
  98. rm -f $rootdir$override
  99. else
  100. echo $"warning: missing $rootdir$override"
  101. fi
  102. done
  103. sync # Flush file buffers before continuing
  104. }
  105. set_apt_sources() {
  106. NEW_MIRROR="$1"
  107. COMPONENTS="main"
  108. cat <<EOF > etc/apt/sources.list
  109. deb $NEW_MIRROR $SUITE $COMPONENTS
  110. deb-src $NEW_MIRROR $SUITE $COMPONENTS
  111. #deb http://security.debian.org/ $SUITE/updates main
  112. #deb-src http://security.debian.org/ $SUITE/updates main
  113. EOF
  114. }
  115. configure_networking() {
  116. if [[ $DEBIAN_INSTALL_ONLY != "no" ]]; then
  117. return
  118. fi
  119. if [[ $GENERIC_IMAGE == "no" ]]; then
  120. echo "# This file describes the network interfaces available on your system
  121. # and how to activate them. For more information, see interfaces(5).
  122. # The loopback network interface
  123. auto lo
  124. iface lo inet loopback
  125. # The primary network interface
  126. auto eth0
  127. iface eth0 inet static
  128. address $BOX_IP_ADDRESS
  129. netmask 255.255.255.0
  130. gateway $ROUTER_IP_ADDRESS
  131. dns-nameservers $NAMESERVER1 $NAMESERVER2
  132. # Example to keep MAC address between reboots
  133. #hwaddress ether B5:A2:BE:3F:1A:FE
  134. # The secondary network interface
  135. #auto eth1
  136. #iface eth1 inet dhcp
  137. # WiFi Example
  138. #auto wlan0
  139. #iface wlan0 inet dhcp
  140. # wpa-ssid \"essid\"
  141. # wpa-psk \"password\"
  142. # Ethernet/RNDIS gadget (g_ether)
  143. # ... or on host side, usbnet and random hwaddr
  144. # Note on some boards, usb0 is automaticly setup with an init script
  145. #iface usb0 inet static
  146. # address 192.168.7.2
  147. # netmask 255.255.255.0
  148. # network 192.168.7.0
  149. # gateway 192.168.7.1" > $rootdir/etc/network/interfaces
  150. hexarray=( 1 2 3 4 5 6 7 8 9 0 a b c d e f )
  151. a=${hexarray[$RANDOM%16]}${hexarray[$RANDOM%16]}
  152. b=${hexarray[$RANDOM%16]}${hexarray[$RANDOM%16]}
  153. c=${hexarray[$RANDOM%16]}${hexarray[$RANDOM%16]}
  154. d=${hexarray[$RANDOM%16]}${hexarray[$RANDOM%16]}
  155. e=${hexarray[$RANDOM%16]}${hexarray[$RANDOM%16]}
  156. sed -i "s|#hwaddress ether.*|hwaddress ether de:$a:$b:$c:$d:$e|g" \
  157. $rootdir/etc/network/interfaces
  158. fi
  159. sed -i "s/nameserver.*/nameserver $NAMESERVER1/g" $rootdir/etc/resolv.conf
  160. sed -i "/nameserver $NAMESERVER1/a\nameserver $NAMESERVER2" $rootdir/etc/resolv.conf
  161. if [[ $VARIANT != "meshclient" && $VARIANT != "meshusb" ]]; then
  162. # change the motd to show further install instructions
  163. echo $"
  164. .---. . .
  165. | | |
  166. |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  167. | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  168. ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  169. Initial base install
  170. Your system is not yet installed. To complete the process run the
  171. following commands, then enter your details.
  172. sudo su
  173. ${PROJECT_NAME} menuconfig
  174. " > $rootdir/etc/motd
  175. else
  176. echo $"
  177. .---. . .
  178. | | |
  179. |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  180. | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  181. ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  182. Freedom in the Mesh
  183. " > $rootdir/etc/motd
  184. fi
  185. }
  186. configure_ssh() {
  187. sed -i "s/Port .*/Port ${SSH_PORT}/g" $rootdir/etc/ssh/sshd_config
  188. if [[ "$SSH_PUBKEY" != "no" ]]; then
  189. if [ ! -d $rootdir/home/$MY_USERNAME/.ssh ]; then
  190. mkdir $rootdir/home/$MY_USERNAME/.ssh
  191. fi
  192. echo "$SSH_PUBKEY" > $rootdir/home/$MY_USERNAME/.ssh/authorized_keys
  193. chroot $rootdir chown -R $MY_USERNAME:$MY_USERNAME /home/$MY_USERNAME/.ssh
  194. sed -i 's|PasswordAuthentication.*|PasswordAuthentication no|g' $rootdir/etc/ssh/sshd_config
  195. echo $"Using ssh public key:"
  196. echo $SSH_PUBKEY
  197. echo $'Password ssh authentication turned off'
  198. fi
  199. }
  200. admin_user_sudo() {
  201. echo "$MY_USERNAME ALL=(ALL) ALL" >> $rootdir/etc/sudoers
  202. }
  203. create_generic_image() {
  204. if [[ $DEBIAN_INSTALL_ONLY != "no" ]]; then
  205. return
  206. fi
  207. if [[ $GENERIC_IMAGE == "no" ]]; then
  208. return
  209. fi
  210. if [ $CONFIG_FILENAME ]; then
  211. if [[ "$CONFIG_FILENAME" == *"mesh.cfg"* ]]; then
  212. VARIANT="mesh"
  213. fi
  214. fi
  215. # Don't install any configuration. This will be a base system
  216. if [[ $VARIANT != "mesh" && $VARIANT != "meshclient" && $VARIANT != "meshusb" ]]; then
  217. CONFIG_FILENAME=
  218. else
  219. touch $rootdir/root/.initial_mesh_setup
  220. fi
  221. # Stick with the existing login for mesh clients
  222. if [[ $VARIANT == "meshclient" || $VARIANT == "meshusb" ]]; then
  223. return
  224. fi
  225. # The presence of this file indicates that the initial
  226. # setup has not yet been completed
  227. touch $rootdir/home/$MY_USERNAME/.initial_setup
  228. chroot $rootdir chown $MY_USERNAME:$MY_USERNAME /home/$MY_USERNAME/.initial_setup
  229. touch $rootdir/root/.initial_setup
  230. cat >> $rootdir/home/$MY_USERNAME/.bashrc <<EOF
  231. # initial setup of the system
  232. if [ -f ~/.initial_setup ]; then
  233. clear
  234. echo "
  235. .---. . .
  236. | | |
  237. |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  238. | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  239. ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  240. Initial setup process
  241. Please enter your password a second time.
  242. "
  243. sudo su
  244. fi
  245. EOF
  246. echo '# initial setup of the system' >> $rootdir/root/.bashrc
  247. echo 'if [ -f ~/.initial_setup ]; then' >> $rootdir/root/.bashrc
  248. echo ' if [ -f ~/login.txt ]; then' >> $rootdir/root/.bashrc
  249. echo ' NEW_USER_PASSWORD=$(printf `cat ~/login.txt`)' >> $rootdir/root/.bashrc
  250. echo ' else' >> $rootdir/root/.bashrc
  251. echo ' ENTROPY=$(cat /proc/sys/kernel/random/entropy_avail)' >> $rootdir/root/.bashrc
  252. echo ' if [ $ENTROPY -lt 500 ]; then' >> $rootdir/root/.bashrc
  253. ENTROPY_MESSAGE1=$'Initial setup process'
  254. ENTROPY_MESSAGE2=$'Password Generation'
  255. ENTROPY_MESSAGE3=$'WARNING: The entropy available on this system is too low to generate a password.\n\nThe installation process cannot continue.'
  256. echo " dialog --backtitle \"${ENTROPY_MESSAGE1}\" --title \"${ENTROPY_MESSAGE2}\" --msgbox \"${ENTROPY_MESSAGE3}\" 8 50" >> $rootdir/root/.bashrc
  257. echo ' exit' >> $rootdir/root/.bashrc
  258. echo ' fi' >> $rootdir/root/.bashrc
  259. echo -n ' NEW_USER_PASSWORD="$(openssl rand -base64 30 | cut -c1-' >> $rootdir/root/.bashrc
  260. echo "${MINIMUM_PASSWORD_LENGTH})\"" >> $rootdir/root/.bashrc
  261. echo ' fi' >> $rootdir/root/.bashrc
  262. echo ' echo "${NEW_USER_PASSWORD}" > ~/login.txt' >> $rootdir/root/.bashrc
  263. echo ' clear' >> $rootdir/root/.bashrc
  264. echo ' echo ""' >> $rootdir/root/.bashrc
  265. NEW_LOGIN_PASSWORD_MESSAGE1=$'Your new login password is:'
  266. NEW_LOGIN_PASSWORD_MESSAGE2=$'Use it whenever you wish to ssh into this system.'
  267. NEW_LOGIN_PASSWORD_MESSAGE3=$'IMPORTANT: Please take a moment to enter the above password into a\npassword manager or write it down somewhere.'
  268. PRESS_KEY_MESSAGE=$'Press any key to continue...'
  269. echo " echo \"${NEW_LOGIN_PASSWORD_MESSAGE1}\"" >> $rootdir/root/.bashrc
  270. echo ' echo ""' >> $rootdir/root/.bashrc
  271. echo ' toilet "${NEW_USER_PASSWORD}"' >> $rootdir/root/.bashrc
  272. echo ' echo ""' >> $rootdir/root/.bashrc
  273. echo ' echo " ${NEW_USER_PASSWORD}"' >> $rootdir/root/.bashrc
  274. echo ' echo ""' >> $rootdir/root/.bashrc
  275. echo " echo \"${NEW_LOGIN_PASSWORD_MESSAGE2}\"" >> $rootdir/root/.bashrc
  276. echo ' echo ""' >> $rootdir/root/.bashrc
  277. echo " echo \"${NEW_LOGIN_PASSWORD_MESSAGE3}\"" >> $rootdir/root/.bashrc
  278. echo ' echo ""' >> $rootdir/root/.bashrc
  279. echo " read -n1 -r -p \"${PRESS_KEY_MESSAGE}\" key" >> $rootdir/root/.bashrc
  280. # change the password for the admin user
  281. echo -n " echo \"${MY_USERNAME}:" >> $rootdir/root/.bashrc
  282. echo '$(printf `cat ~/login.txt`)"|chpasswd' >> $rootdir/root/.bashrc
  283. # update before continuing
  284. echo " cd /root/${PROJECT_NAME}" >> $rootdir/root/.bashrc
  285. echo " git stash" >> $rootdir/root/.bashrc
  286. echo " git pull" >> $rootdir/root/.bashrc
  287. echo " make install" >> $rootdir/root/.bashrc
  288. if [[ $VARIANT != "mesh" && $VARIANT != "meshclient" && $VARIANT != "meshusb" && $VARIANT != "usb" ]]; then
  289. if [[ $ONION_ONLY == "no" ]]; then
  290. if [[ $MINIMAL_INSTALL == "no" ]]; then
  291. echo " ${PROJECT_NAME} menuconfig-full" >> $rootdir/root/.bashrc
  292. else
  293. echo " ${PROJECT_NAME} menuconfig" >> $rootdir/root/.bashrc
  294. fi
  295. else
  296. echo " ${PROJECT_NAME} menuconfig-onion" >> $rootdir/root/.bashrc
  297. fi
  298. else
  299. echo " echo ''" >> $rootdir/root/.bashrc
  300. fi
  301. echo ' if [ "$?" = "0" ]; then' >> $rootdir/root/.bashrc
  302. echo " if [ -f ~/${PROJECT_NAME}-completed.txt ]; then" >> $rootdir/root/.bashrc
  303. # Remove the initial setup files
  304. echo ' rm /root/.initial_setup' >> $rootdir/root/.bashrc
  305. echo " rm /home/${MY_USERNAME}/.initial_setup" >> $rootdir/root/.bashrc
  306. echo " touch /root/.remove_${GENERIC_IMAGE_USERNAME}" >> $rootdir/root/.bashrc
  307. echo ' shred -zu ~/login.txt' >> $rootdir/root/.bashrc
  308. END_MESSAGE1=$'Congratulations!'
  309. if [[ $VARIANT != "mesh" && $VARIANT != "meshclient" && $VARIANT != "meshusb" && $VARIANT != "usb" ]]; then
  310. END_MESSAGE2=$'\nYour system has now installed\n\nThe onion ssh service is at $SSH_ONION_HOSTNAME\n\nPress any key to reboot and begin using it'
  311. echo ' SSH_ONION_HOSTNAME=$(cat /var/lib/tor/hidden_service_ssh/hostname)' >> $rootdir/root/.bashrc
  312. else
  313. END_MESSAGE2=$'\nYour system has now installed\n\nPress any key to reboot and begin using it'
  314. fi
  315. echo " dialog --title '$END_MESSAGE1' --msgbox \"$END_MESSAGE2\" 9 50" >> $rootdir/root/.bashrc
  316. echo ' reboot' >> $rootdir/root/.bashrc
  317. echo ' fi' >> $rootdir/root/.bashrc
  318. echo ' else' >> $rootdir/root/.bashrc
  319. echo ' key=' >> $rootdir/root/.bashrc
  320. echo ' while [[ $key != "x" ]]; do' >> $rootdir/root/.bashrc
  321. INSTALL_FAIL_MESSAGE=$"Install failed. Press x to continue..."
  322. echo " read -n1 -r -p \"${INSTALL_FAIL_MESSAGE}\" key" >> $rootdir/root/.bashrc
  323. echo ' done' >> $rootdir/root/.bashrc
  324. echo ' fi' >> $rootdir/root/.bashrc
  325. echo ' exit' >> $rootdir/root/.bashrc
  326. echo 'else' >> $rootdir/root/.bashrc
  327. echo ' # Remove default account after install' >> $rootdir/root/.bashrc
  328. echo " if [ -f /root/.remove_${GENERIC_IMAGE_USERNAME} ]; then" >> $rootdir/root/.bashrc
  329. echo " if [ -d /home/${GENERIC_IMAGE_USERNAME} ]; then" >> $rootdir/root/.bashrc
  330. echo " userdel -r ${GENERIC_IMAGE_USERNAME}" >> $rootdir/root/.bashrc
  331. echo " if [ -d /home/${GENERIC_IMAGE_USERNAME} ]; then" >> $rootdir/root/.bashrc
  332. echo " rm -rf /home/${GENERIC_IMAGE_USERNAME}" >> $rootdir/root/.bashrc
  333. echo " rm /root/.remove_${GENERIC_IMAGE_USERNAME}" >> $rootdir/root/.bashrc
  334. echo ' fi' >> $rootdir/root/.bashrc
  335. echo ' fi' >> $rootdir/root/.bashrc
  336. echo ' fi' >> $rootdir/root/.bashrc
  337. echo 'fi' >> $rootdir/root/.bashrc
  338. }
  339. continue_installation() {
  340. # If a configuration file exists then run with it
  341. # otherwise the interactive installer can be used
  342. # This is equivalent to installing freedombox-setup on freedombox
  343. if [ $CONFIG_FILENAME ]; then
  344. if [ ${#CONFIG_FILENAME} -gt 2 ]; then
  345. cp $CONFIG_FILENAME $rootdir/root/$PROJECT_NAME.cfg
  346. cat $rootdir/root/$PROJECT_NAME.cfg
  347. chroot "$rootdir" su -c "$PROJECT_NAME -c /root/$PROJECT_NAME.cfg" - root
  348. fi
  349. fi
  350. }
  351. atheros_wifi() {
  352. firmware_filename="open-ath9k-htc-firmware_1.3-1_all.deb"
  353. firmware_hash='5fea58ffefdf0ef15b504db7fbe3bc078c03e0d927bba64085e4b6f2546102f5'
  354. firmware_url="http://us.archive.trisquel.info/trisquel/pool/main/o/open-ath9k-htc-firmware/$firmware_filename"
  355. firmware_tempfile="/tmp/$firmware_filename"
  356. wget "$firmware_url" -O "$rootdir$firmware_tempfile"
  357. downloaded_firmware_hash=$(sha256sum "$rootdir$firmware_tempfile" | awk -F ' ' '{print $1}')
  358. if [[ "$downloaded_firmware_hash" == "$firmware_hash" ]]; then
  359. chroot "$rootdir" dpkg -i "$firmware_tempfile"
  360. else
  361. echo 'WARNING: Atheros Wifi firmware hash does not match. The driver has not been installed.'
  362. fi
  363. }
  364. configure_wifi() {
  365. if [[ $VARIANT == "mesh" || $VARIANT == "meshclient" || $VARIANT == "meshusb" ]]; then
  366. return
  367. fi
  368. if [ -f $WIFI_NETWORKS_FILE ]; then
  369. chroot "$rootdir" ${PROJECT_NAME}-wifi -i $WIFI_INTERFACE --networks $WIFI_NETWORKS_FILE
  370. return
  371. fi
  372. if [[ $WIFI_TYPE != 'none' ]]; then
  373. if [ ${#WIFI_PASSPHRASE} -lt 2 ]; then
  374. return
  375. fi
  376. chroot "$rootdir" ${PROJECT_NAME}-wifi -i $WIFI_INTERFACE -s $WIFI_SSID -t $WIFI_TYPE -p $WIFI_PASSPHRASE --hotspot $WIFI_HOTSPOT
  377. else
  378. chroot "$rootdir" ${PROJECT_NAME}-wifi -i $WIFI_INTERFACE -s $WIFI_SSID -t $WIFI_TYPE --hotspot $WIFI_HOTSPOT
  379. fi
  380. }
  381. ##############################################################################
  382. # Mesh networking
  383. ##############################################################################
  384. # for mesh installs
  385. TRACKER_PORT=6969
  386. WIFI_CHANNEL=2
  387. # B.A.T.M.A.N settings
  388. BATMAN_CELLID='02:BA:00:00:03:01'
  389. WIFI_SSID='mesh'
  390. # To avoid confusions these are obtained from the main project file
  391. TOXID_REPO=
  392. TOX_PORT=
  393. TOXCORE_REPO=
  394. TOXIC_REPO=
  395. TOXCORE_COMMIT=
  396. TOXIC_COMMIT=
  397. # These are some default nodes, but you can replace them with trusted nodes
  398. # as you prefer. See https://wiki.tox.im/Nodes
  399. TOX_NODES=
  400. #TOX_NODES=(
  401. # '192.254.75.102,2607:5600:284::2,33445,951C88B7E75C867418ACDB5D273821372BB5BD652740BCDF623A4FA293E75D2F,Tox RELENG,US'
  402. # '144.76.60.215,2a01:4f8:191:64d6::1,33445,04119E835DF3E78BACF0F84235B300546AF8B936F035185E2A8E9E0A67C8924F,sonOfRa,DE'
  403. #)
  404. # To avoid confusions these are obtained from the main project file
  405. ZERONET_REPO=
  406. ZERONET_COMMIT=
  407. ZERONET_PORT=
  408. # Directory where source code is downloaded and compiled
  409. INSTALL_DIR=$HOME/build
  410. function mesh_avahi {
  411. chroot "$rootdir" apt-get -y install avahi-utils avahi-autoipd avahi-dnsconfd
  412. decarray=( 1 2 3 4 5 6 7 8 9 0 )
  413. PEER_ID=${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}${decarray[$RANDOM%10]}
  414. sed -i "s|#host-name=.*|host-name=P$PEER_ID|g" $rootdir/etc/avahi/avahi-daemon.conf
  415. if [ ! -d $rootdir/etc/avahi/services ]; then
  416. mkdir -p $rootdir/etc/avahi/services
  417. fi
  418. # remove an avahi service which isn't used
  419. if [ -f $rootdir/etc/avahi/services/udisks.service ]; then
  420. rm $rootdir/etc/avahi/services/udisks.service
  421. fi
  422. # Add an ssh service
  423. echo '<?xml version="1.0" standalone="no"?><!--*-nxml-*-->' > $rootdir/etc/avahi/services/ssh.service
  424. echo '<!DOCTYPE service-group SYSTEM "avahi-service.dtd">' >> $rootdir/etc/avahi/services/ssh.service
  425. echo '<service-group>' >> $rootdir/etc/avahi/services/ssh.service
  426. echo ' <name replace-wildcards="yes">%h SSH</name>' >> $rootdir/etc/avahi/services/ssh.service
  427. echo ' <service>' >> $rootdir/etc/avahi/services/ssh.service
  428. echo ' <type>_ssh._tcp</type>' >> $rootdir/etc/avahi/services/ssh.service
  429. echo " <port>$SSH_PORT</port>" >> $rootdir/etc/avahi/services/ssh.service
  430. echo ' </service>' >> $rootdir/etc/avahi/services/ssh.service
  431. echo '</service-group>' >> $rootdir/etc/avahi/services/ssh.service
  432. # keep the daemon running
  433. WATCHDOG_SCRIPT_NAME="keepon"
  434. echo '' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  435. echo '# keep avahi daemon running' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  436. echo 'AVAHI_RUNNING=$(pgrep avahi-daemon > /dev/null && echo Running)' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  437. echo 'if [ ! $AVAHI_RUNNING ]; then' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  438. echo ' systemctl start avahi-daemon' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  439. echo ' echo -n $CURRENT_DATE >> $LOGFILE' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  440. echo ' echo " Avahi daemon restarted" >> $LOGFILE' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  441. echo 'fi' >> $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  442. chmod +x $rootdir/usr/bin/$WATCHDOG_SCRIPT_NAME
  443. }
  444. function mesh_batman {
  445. chroot "$rootdir" apt-get -y install iproute bridge-utils libnetfilter-conntrack3 batctl
  446. chroot "$rootdir" apt-get -y install python-dev libevent-dev ebtables python-pip git
  447. chroot "$rootdir" apt-get -y install wireless-tools rfkill
  448. if ! grep -q "batman_adv" $rootdir/etc/modules; then
  449. echo 'batman_adv' >> $rootdir/etc/modules
  450. fi
  451. BATMAN_SCRIPT=$rootdir/var/lib/batman
  452. if [ -f /usr/local/bin/${PROJECT_NAME}-mesh-batman ]; then
  453. cp /usr/local/bin/${PROJECT_NAME}-mesh-batman $BATMAN_SCRIPT
  454. else
  455. cp /usr/bin/${PROJECT_NAME}-mesh-batman $BATMAN_SCRIPT
  456. fi
  457. BATMAN_DAEMON=$rootdir/etc/systemd/system/batman.service
  458. echo '[Unit]' > $BATMAN_DAEMON
  459. echo 'Description=B.A.T.M.A.N. Advanced' >> $BATMAN_DAEMON
  460. echo '' >> $BATMAN_DAEMON
  461. echo '[Service]' >> $BATMAN_DAEMON
  462. echo 'Type=oneshot' >> $BATMAN_DAEMON
  463. echo "ExecStart=/var/lib/batman start" >> $BATMAN_DAEMON
  464. echo "ExecStop=/var/lib/batman stop" >> $BATMAN_DAEMON
  465. echo 'RemainAfterExit=yes' >> $BATMAN_DAEMON
  466. echo '' >> $BATMAN_DAEMON
  467. echo '# Allow time for the server to start/stop' >> $BATMAN_DAEMON
  468. echo 'TimeoutSec=300' >> $BATMAN_DAEMON
  469. echo '' >> $BATMAN_DAEMON
  470. echo '[Install]' >> $BATMAN_DAEMON
  471. echo 'WantedBy=multi-user.target' >> $BATMAN_DAEMON
  472. chroot "$rootdir" systemctl enable batman
  473. }
  474. function mesh_firewall {
  475. FIREWALL_FILENAME=${rootdir}/etc/systemd/system/meshfirewall.service
  476. MESH_FIREWALL_SCRIPT=${rootdir}/usr/bin/mesh-firewall
  477. echo '#!/bin/bash' > $MESH_FIREWALL_SCRIPT
  478. echo 'iptables -P INPUT ACCEPT' >> $MESH_FIREWALL_SCRIPT
  479. echo 'ip6tables -P INPUT ACCEPT' >> $MESH_FIREWALL_SCRIPT
  480. echo 'iptables -F' >> $MESH_FIREWALL_SCRIPT
  481. echo 'ip6tables -F' >> $MESH_FIREWALL_SCRIPT
  482. echo 'iptables -t nat -F' >> $MESH_FIREWALL_SCRIPT
  483. echo 'ip6tables -t nat -F' >> $MESH_FIREWALL_SCRIPT
  484. echo 'iptables -X' >> $MESH_FIREWALL_SCRIPT
  485. echo 'ip6tables -X' >> $MESH_FIREWALL_SCRIPT
  486. echo 'iptables -P INPUT DROP' >> $MESH_FIREWALL_SCRIPT
  487. echo 'ip6tables -P INPUT DROP' >> $MESH_FIREWALL_SCRIPT
  488. echo 'iptables -A INPUT -i lo -j ACCEPT' >> $MESH_FIREWALL_SCRIPT
  489. echo 'iptables -A INPUT -m conntrack --ctstate ESTABLISHED,RELATED -j ACCEPT' >> $MESH_FIREWALL_SCRIPT
  490. echo '' >> $MESH_FIREWALL_SCRIPT
  491. echo '# Make sure incoming tcp connections are SYN packets' >> $MESH_FIREWALL_SCRIPT
  492. echo 'iptables -A INPUT -p tcp ! --syn -m state --state NEW -j DROP' >> $MESH_FIREWALL_SCRIPT
  493. echo '' >> $MESH_FIREWALL_SCRIPT
  494. echo '# Drop packets with incoming fragments' >> $MESH_FIREWALL_SCRIPT
  495. echo 'iptables -A INPUT -f -j DROP' >> $MESH_FIREWALL_SCRIPT
  496. echo '' >> $MESH_FIREWALL_SCRIPT
  497. echo '# Drop bogons' >> $MESH_FIREWALL_SCRIPT
  498. echo 'iptables -A INPUT -p tcp --tcp-flags ALL ALL -j DROP' >> $MESH_FIREWALL_SCRIPT
  499. echo 'iptables -A INPUT -p tcp --tcp-flags ALL FIN,PSH,URG -j DROP' >> $MESH_FIREWALL_SCRIPT
  500. echo 'iptables -A INPUT -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j DROP' >> $MESH_FIREWALL_SCRIPT
  501. echo '' >> $MESH_FIREWALL_SCRIPT
  502. echo '# Incoming malformed NULL packets:' >> $MESH_FIREWALL_SCRIPT
  503. echo 'iptables -A INPUT -p tcp --tcp-flags ALL NONE -j DROP' >> $MESH_FIREWALL_SCRIPT
  504. echo '' >> $MESH_FIREWALL_SCRIPT
  505. echo "iptables -A INPUT -p tcp --dport $TOX_PORT -j ACCEPT" >> $MESH_FIREWALL_SCRIPT
  506. echo "iptables -A INPUT -i $WIFI_INTERFACE -p udp --dport $ZERONET_PORT -j ACCEPT" >> $MESH_FIREWALL_SCRIPT
  507. echo "iptables -A INPUT -i $WIFI_INTERFACE -p tcp --dport $ZERONET_PORT -j ACCEPT" >> $MESH_FIREWALL_SCRIPT
  508. echo "iptables -A INPUT -i $WIFI_INTERFACE -p udp --dport $TRACKER_PORT -j ACCEPT" >> $MESH_FIREWALL_SCRIPT
  509. echo "iptables -A INPUT -i $WIFI_INTERFACE -p tcp --dport $TRACKER_PORT -j ACCEPT" >> $MESH_FIREWALL_SCRIPT
  510. echo "iptables -A INPUT -i $WIFI_INTERFACE -p udp --dport 1900 -j ACCEPT" >> $MESH_FIREWALL_SCRIPT
  511. chmod +x $MESH_FIREWALL_SCRIPT
  512. echo '[Unit]' > $FIREWALL_FILENAME
  513. echo 'Description=Mesh Firewall' >> $FIREWALL_FILENAME
  514. echo '' >> $FIREWALL_FILENAME
  515. echo '[Service]' >> $FIREWALL_FILENAME
  516. echo 'Type=oneshot' >> $FIREWALL_FILENAME
  517. echo 'ExecStart=/usr/bin/mesh-firewall' >> $FIREWALL_FILENAME
  518. echo 'RemainAfterExit=no' >> $FIREWALL_FILENAME
  519. echo '' >> $FIREWALL_FILENAME
  520. echo 'TimeoutSec=30' >> $FIREWALL_FILENAME
  521. echo '' >> $FIREWALL_FILENAME
  522. echo '[Install]' >> $FIREWALL_FILENAME
  523. echo 'WantedBy=multi-user.target' >> $FIREWALL_FILENAME
  524. chroot "$rootdir" systemctl enable meshfirewall
  525. }
  526. function mesh_tox_node {
  527. # obtain commits from the main file
  528. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  529. TOXCORE_COMMIT_MAIN=$(cat /usr/local/bin/${PROJECT_NAME} | grep "TOXCORE_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  530. else
  531. TOXCORE_COMMIT_MAIN=$(cat /usr/bin/${PROJECT_NAME} | grep "TOXCORE_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  532. fi
  533. if [ ${#TOXCORE_COMMIT_MAIN} -gt 10 ]; then
  534. TOXCORE_COMMIT=$TOXCORE_COMMIT_MAIN
  535. fi
  536. if [ ! $TOXCORE_COMMIT ]; then
  537. echo $'No Tox commit was specified'
  538. exit 76325
  539. fi
  540. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  541. TOX_PORT_MAIN=$(cat /usr/local/bin/${PROJECT_NAME} | grep "TOX_PORT=" | head -n 1 | awk -F '=' '{print $2}')
  542. else
  543. TOX_PORT_MAIN=$(cat /usr/bin/${PROJECT_NAME} | grep "TOX_PORT=" | head -n 1 | awk -F '=' '{print $2}')
  544. fi
  545. if [ ${#TOX_PORT_MAIN} -gt 2 ]; then
  546. TOX_PORT=$TOX_PORT_MAIN
  547. fi
  548. if [ ! $TOX_PORT ]; then
  549. echo $'No Tox port was specified'
  550. exit 32856
  551. fi
  552. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  553. TOXCORE_REPO_MAIN=$(cat /usr/local/bin/${PROJECT_NAME} | grep "TOXCORE_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  554. else
  555. TOXCORE_REPO_MAIN=$(cat /usr/bin/${PROJECT_NAME} | grep "TOXCORE_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  556. fi
  557. if [ ${#TOXCORE_REPO_MAIN} -gt 10 ]; then
  558. TOXCORE_REPO=$TOXCORE_REPO_MAIN
  559. fi
  560. if [ ! $TOXCORE_REPO ]; then
  561. echo $'No Tox repo was specified'
  562. exit 16865
  563. fi
  564. chroot "$rootdir" apt-get -y install build-essential libtool autotools-dev
  565. chroot "$rootdir" apt-get -y install automake checkinstall check git yasm
  566. chroot "$rootdir" apt-get -y install libsodium13 libsodium-dev libcap2-bin
  567. chroot "$rootdir" apt-get -y install libconfig9 libconfig-dev
  568. TEMP_SCRIPT_NAME=fbtmp37272.sh
  569. TEMP_SCRIPT=/tmp/$TEMP_SCRIPT_NAME
  570. echo '#!/bin/bash' > $TEMP_SCRIPT
  571. echo "mkdir -p $INSTALL_DIR" >> $TEMP_SCRIPT
  572. echo "git clone $TOXCORE_REPO $INSTALL_DIR/toxcore" >> $TEMP_SCRIPT
  573. echo "cd $INSTALL_DIR/toxcore" >> $TEMP_SCRIPT
  574. echo "git checkout $TOXCORE_COMMIT -b $TOXCORE_COMMIT" >> $TEMP_SCRIPT
  575. echo 'autoreconf -i' >> $TEMP_SCRIPT
  576. echo './configure --enable-daemon --disable-av' >> $TEMP_SCRIPT
  577. echo 'make' >> $TEMP_SCRIPT
  578. echo 'if [ ! "$?" = "0" ]; then' >> $TEMP_SCRIPT
  579. echo ' exit 1' >> $TEMP_SCRIPT
  580. echo 'fi' >> $TEMP_SCRIPT
  581. echo 'make install' >> $TEMP_SCRIPT
  582. echo 'cp /usr/local/lib/libtoxcore* /usr/lib/' >> $TEMP_SCRIPT
  583. echo "cp $INSTALL_DIR/toxcore/other/bootstrap_daemon/tox-bootstrapd.service /etc/systemd/system/" >> $TEMP_SCRIPT
  584. echo "sed -i 's|ExecStart=.*|ExecStart=/usr/local/bin/tox-bootstrapd --config /etc/tox-bootstrapd.conf|g' /etc/systemd/system/tox-bootstrapd.service" >> $TEMP_SCRIPT
  585. echo 'systemctl enable tox-bootstrapd.service' >> $TEMP_SCRIPT
  586. echo 'exit 0' >> $TEMP_SCRIPT
  587. chmod +x $TEMP_SCRIPT
  588. cp $TEMP_SCRIPT $rootdir/root/
  589. SECONDS=0
  590. chroot "$rootdir" /root/$TEMP_SCRIPT_NAME
  591. if [ ! "$?" = "0" ]; then
  592. duration=$SECONDS
  593. echo $"Toxcore compile failed at $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  594. echo $'Unable to make toxcore'
  595. rm $TEMP_SCRIPT
  596. exit 73835
  597. fi
  598. duration=$SECONDS
  599. echo $"Toxcore compile $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  600. rm $TEMP_SCRIPT
  601. if [ ! -f $rootdir/usr/local/bin/tox-bootstrapd ]; then
  602. echo $"File not found /usr/local/bin/tox-bootstrapd"
  603. exit 37825
  604. fi
  605. chroot "$rootdir" useradd --home-dir /var/lib/tox-bootstrapd --create-home --system --shell /sbin/nologin --comment $"Account to run Tox's DHT bootstrap daemon" --user-group tox-bootstrapd
  606. chroot "$rootdir" chmod 700 /var/lib/tox-bootstrapd
  607. # remove Maildir
  608. if [ -d $rootdir/var/lib/tox-bootstrapd/Maildir ]; then
  609. rm -rf $rootdir/var/lib/tox-bootstrapd/Maildir
  610. fi
  611. # create configuration file
  612. TOX_BOOTSTRAP_CONFIG=$rootdir/etc/tox-bootstrapd.conf
  613. echo "port = $TOX_PORT" > $TOX_BOOTSTRAP_CONFIG
  614. echo 'keys_file_path = "/var/lib/tox-bootstrapd/keys"' >> $TOX_BOOTSTRAP_CONFIG
  615. echo 'pid_file_path = "/var/run/tox-bootstrapd/tox-bootstrapd.pid"' >> $TOX_BOOTSTRAP_CONFIG
  616. echo 'enable_ipv6 = true' >> $TOX_BOOTSTRAP_CONFIG
  617. echo 'enable_ipv4_fallback = true' >> $TOX_BOOTSTRAP_CONFIG
  618. echo 'enable_lan_discovery = true' >> $TOX_BOOTSTRAP_CONFIG
  619. echo 'enable_tcp_relay = true' >> $TOX_BOOTSTRAP_CONFIG
  620. echo "tcp_relay_ports = [443, 3389, $TOX_PORT]" >> $TOX_BOOTSTRAP_CONFIG
  621. echo 'enable_motd = true' >> $TOX_BOOTSTRAP_CONFIG
  622. echo 'motd = "tox-bootstrapd"' >> $TOX_BOOTSTRAP_CONFIG
  623. if [ $TOX_NODES ]; then
  624. echo 'bootstrap_nodes = (' >> $TOX_BOOTSTRAP_CONFIG
  625. toxcount=0
  626. while [ "x${TOX_NODES[toxcount]}" != "x" ]
  627. do
  628. toxval_ipv4=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $1}')
  629. toxval_ipv6=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $2}')
  630. toxval_port=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $3}')
  631. toxval_pubkey=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $4}')
  632. toxval_maintainer=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $5}')
  633. echo "{ // $toxval_maintainer" >> $TOX_BOOTSTRAP_CONFIG
  634. if [[ $toxval_ipv6 != 'NONE' ]]; then
  635. echo " address = \"$toxval_ipv6\"" >> $TOX_BOOTSTRAP_CONFIG
  636. else
  637. echo " address = \"$toxval_ipv4\"" >> $TOX_BOOTSTRAP_CONFIG
  638. fi
  639. echo " port = $toxval_port" >> $TOX_BOOTSTRAP_CONFIG
  640. echo " public_key = \"$toxval_pubkey\"" >> $TOX_BOOTSTRAP_CONFIG
  641. toxcount=$(( $toxcount + 1 ))
  642. if [ "x${TOX_NODES[toxcount]}" != "x" ]; then
  643. echo "}," >> $TOX_BOOTSTRAP_CONFIG
  644. else
  645. echo "}" >> $TOX_BOOTSTRAP_CONFIG
  646. fi
  647. done
  648. echo ')' >> $TOX_BOOTSTRAP_CONFIG
  649. fi
  650. }
  651. function mesh_tox_avahi {
  652. if [ ! -d $rootdir/etc/avahi ]; then
  653. echo $'tox_avahi: avahi is not installed'
  654. exit 87359
  655. fi
  656. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  657. TOXID_REPO_MAIN=$(cat /usr/local/bin/${PROJECT_NAME} | grep "TOXID_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  658. else
  659. TOXID_REPO_MAIN=$(cat /usr/bin/${PROJECT_NAME} | grep "TOXID_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  660. fi
  661. if [ ${#TOXID_REPO_MAIN} -gt 5 ]; then
  662. TOXID_REPO=$TOXID_REPO_MAIN
  663. fi
  664. if [ ! $TOXID_REPO ]; then
  665. echo $'No ToxID repo was specified'
  666. exit 78252
  667. fi
  668. TEMP_SCRIPT_NAME=fbtmp5328252.sh
  669. TEMP_SCRIPT=/tmp/$TEMP_SCRIPT_NAME
  670. echo '#!/bin/bash' > $TEMP_SCRIPT
  671. echo "mkdir -p $INSTALL_DIR" >> $TEMP_SCRIPT
  672. echo "git clone $TOXID_REPO $INSTALL_DIR/toxid" >> $TEMP_SCRIPT
  673. echo "if [ ! -d $INSTALL_DIR/toxid ]; then" >> $TEMP_SCRIPT
  674. echo ' exit 1' >> $TEMP_SCRIPT
  675. echo 'fi' >> $TEMP_SCRIPT
  676. echo "cd $INSTALL_DIR/toxid" >> $TEMP_SCRIPT
  677. echo "make" >> $TEMP_SCRIPT
  678. echo 'if [ ! "$?" = "0" ]; then' >> $TEMP_SCRIPT
  679. echo ' exit 2' >> $TEMP_SCRIPT
  680. echo 'fi' >> $TEMP_SCRIPT
  681. echo 'make install' >> $TEMP_SCRIPT
  682. echo 'if [ ! -f /usr/local/bin/toxavahi ]; then' >> $TEMP_SCRIPT
  683. echo ' exit 3' >> $TEMP_SCRIPT
  684. echo 'fi' >> $TEMP_SCRIPT
  685. echo 'toxavahi' >> $TEMP_SCRIPT
  686. echo 'echo "* * * * * root /usr/local/bin/toxavahi > /dev/null" >> /etc/crontab' >> $TEMP_SCRIPT
  687. echo 'systemctl restart avahi-daemon' >> $TEMP_SCRIPT
  688. echo 'exit 0' >> $TEMP_SCRIPT
  689. chmod +x $TEMP_SCRIPT
  690. cp $TEMP_SCRIPT $rootdir/root/
  691. chroot "$rootdir" /root/$TEMP_SCRIPT_NAME
  692. if [ ! "$?" = "0" ]; then
  693. echo $"Unable to install toxid, returned $?"
  694. rm $TEMP_SCRIPT
  695. exit 62835
  696. fi
  697. rm $TEMP_SCRIPT
  698. }
  699. function mesh_tox_client {
  700. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  701. TOXIC_FILE=$(cat /usr/local/bin/${PROJECT_NAME} | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
  702. else
  703. TOXIC_FILE=$(cat /usr/bin/${PROJECT_NAME} | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
  704. fi
  705. # obtain commits from the main file
  706. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  707. TOXIC_COMMIT_MAIN=$(cat /usr/local/bin/${PROJECT_NAME} | grep "TOXIC_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  708. else
  709. TOXIC_COMMIT_MAIN=$(cat /usr/bin/${PROJECT_NAME} | grep "TOXIC_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  710. fi
  711. if [ ${#TOXIC_COMMIT_MAIN} -gt 10 ]; then
  712. TOXIC_COMMIT=$TOXIC_COMMIT_MAIN
  713. fi
  714. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  715. TOXIC_REPO_MAIN=$(cat /usr/local/bin/${PROJECT_NAME} | grep "TOXIC_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  716. else
  717. TOXIC_REPO_MAIN=$(cat /usr/bin/${PROJECT_NAME} | grep "TOXIC_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  718. fi
  719. if [ ${#TOXIC_REPO_MAIN} -gt 5 ]; then
  720. TOXIC_REPO=$TOXIC_REPO_MAIN
  721. fi
  722. chroot "$rootdir" apt-get -y install libncursesw5-dev libconfig-dev libqrencode-dev
  723. chroot "$rootdir" apt-get -y install libcurl4-openssl-dev libvpx-dev libopenal-dev
  724. TEMP_SCRIPT_NAME=fbtmp728353.sh
  725. TEMP_SCRIPT=/tmp/$TEMP_SCRIPT_NAME
  726. echo '#!/bin/bash' > $TEMP_SCRIPT
  727. echo "mkdir -p $INSTALL_DIR" >> $TEMP_SCRIPT
  728. echo "git clone $TOXIC_REPO $INSTALL_DIR/toxic" >> $TEMP_SCRIPT
  729. echo "cd $INSTALL_DIR/toxic" >> $TEMP_SCRIPT
  730. echo "git checkout $TOXIC_COMMIT -b $TOXIC_COMMIT" >> $TEMP_SCRIPT
  731. echo 'make' >> $TEMP_SCRIPT
  732. echo 'if [ ! "$?" = "0" ]; then' >> $TEMP_SCRIPT
  733. echo ' exit 1' >> $TEMP_SCRIPT
  734. echo 'fi' >> $TEMP_SCRIPT
  735. echo 'make install' >> $TEMP_SCRIPT
  736. echo 'exit 0' >> $TEMP_SCRIPT
  737. chmod +x $TEMP_SCRIPT
  738. cp $TEMP_SCRIPT $rootdir/root/
  739. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  740. TOXIC_FILE=$(cat /usr/local/bin/${PROJECT_NAME} | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
  741. else
  742. TOXIC_FILE=$(cat /usr/bin/${PROJECT_NAME} | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
  743. fi
  744. SECONDS=0
  745. chroot "$rootdir" /root/$TEMP_SCRIPT_NAME
  746. if [ ! "$?" = "0" ]; then
  747. duration=$SECONDS
  748. echo $"Toxic client compile failed at $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  749. echo $'Unable to make tox client'
  750. rm $TEMP_SCRIPT
  751. exit 74872
  752. fi
  753. rm $TEMP_SCRIPT
  754. if [ ! -f $rootdir$TOXIC_FILE ]; then
  755. echo $"Tox client was not installed to $TOXIC_FILE"
  756. exit 63278
  757. fi
  758. duration=$SECONDS
  759. echo $"Toxic client compile $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  760. }
  761. function mesh_zeronet {
  762. # obtain commits from the main file
  763. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  764. ZERONET_COMMIT_MAIN=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  765. else
  766. ZERONET_COMMIT_MAIN=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  767. fi
  768. if [ ${#ZERONET_COMMIT_MAIN} -gt 10 ]; then
  769. ZERONET_COMMIT=$ZERONET_COMMIT_MAIN
  770. fi
  771. if [ ! $ZERONET_COMMIT ]; then
  772. echo $'No Tox commit was specified'
  773. exit 37046
  774. fi
  775. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  776. ZERONET_REPO_MAIN=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  777. else
  778. ZERONET_REPO_MAIN=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  779. fi
  780. if [ ${#ZERONET_REPO_MAIN} -gt 5 ]; then
  781. ZERONET_REPO=$ZERONET_REPO_MAIN
  782. fi
  783. if [ ! $ZERONET_REPO ]; then
  784. echo $'No Tox commit was specified'
  785. exit 37046
  786. fi
  787. if [ -f /usr/local/bin/${PROJECT_NAME} ]; then
  788. ZERONET_PORT_MAIN=$(cat /usr/local/bin/${PROJECT_NAME} | grep "ZERONET_PORT=" | head -n 1 | awk -F '=' '{print $2}')
  789. else
  790. ZERONET_PORT_MAIN=$(cat /usr/bin/${PROJECT_NAME} | grep "ZERONET_PORT=" | head -n 1 | awk -F '=' '{print $2}')
  791. fi
  792. if [ ${#ZERONET_PORT_MAIN} -gt 1 ]; then
  793. ZERONET_PORT=$ZERONET_PORT_MAIN
  794. fi
  795. if [ ! $ZERONET_PORT ]; then
  796. echo $'No zeronet port was specified'
  797. exit 67433
  798. fi
  799. chroot "$rootdir" apt-get -y install python python-msgpack python-gevent
  800. chroot "$rootdir" apt-get -y install python-pip bittornado
  801. chroot "$rootdir" pip install msgpack-python --upgrade
  802. chroot "$rootdir" useradd -d /opt/zeronet/ -s /bin/false zeronet
  803. git clone $ZERONET_REPO $rootdir/opt/zeronet
  804. if [ ! -d $rootdir/opt/zeronet ]; then
  805. echo 'WARNING: Unable to clone zeronet'
  806. return
  807. fi
  808. cd $rootdir/opt/zeronet
  809. git checkout $ZERONET_COMMIT -b $ZERONET_COMMIT
  810. if ! grep -q "ZeroNet commit" $COMPLETION_FILE; then
  811. echo "ZeroNet commit:$ZERONET_COMMIT" >> $rootdir$COMPLETION_FILE
  812. else
  813. sed -i "s/ZeroNet commit.*/ZeroNet commit:$ZERONET_COMMIT/g" $COMPLETION_FILE
  814. fi
  815. chroot "$rootdir" chown -R zeronet:zeronet /opt/zeronet
  816. # Hack to ensure that the file access port is opened
  817. # This is because zeronet normally relies on an internet site
  818. # to do this, but on a purely local mesh the internet isn't available
  819. sed -i 's|fileserver_port = 0|fileserver_port = config.fileserver_port\n sys.modules["main"].file_server.port_opened = True|g' $rootdir/opt/zeronet/src/Site/Site.py
  820. ZERONET_DAEMON=$rootdir/etc/systemd/system/zeronet.service
  821. echo '[Unit]' > $ZERONET_DAEMON
  822. echo 'Description=Zeronet Server' >> $ZERONET_DAEMON
  823. echo 'After=syslog.target' >> $ZERONET_DAEMON
  824. echo 'After=network.target' >> $ZERONET_DAEMON
  825. echo '[Service]' >> $ZERONET_DAEMON
  826. echo 'Type=simple' >> $ZERONET_DAEMON
  827. echo 'User=zeronet' >> $ZERONET_DAEMON
  828. echo 'Group=zeronet' >> $ZERONET_DAEMON
  829. echo 'WorkingDirectory=/opt/zeronet' >> $ZERONET_DAEMON
  830. echo 'ExecStart=/usr/bin/python zeronet.py --ip_external replace.local --trackers_file /opt/zeronet/bootstrap' >> $ZERONET_DAEMON
  831. echo '' >> $ZERONET_DAEMON
  832. echo 'TimeoutSec=300' >> $ZERONET_DAEMON
  833. echo '' >> $ZERONET_DAEMON
  834. echo '[Install]' >> $ZERONET_DAEMON
  835. echo 'WantedBy=multi-user.target' >> $ZERONET_DAEMON
  836. TRACKER_DAEMON=$rootdir/etc/systemd/system/tracker.service
  837. echo '[Unit]' > $TRACKER_DAEMON
  838. echo 'Description=Torrent Tracker' >> $TRACKER_DAEMON
  839. echo 'After=syslog.target' >> $TRACKER_DAEMON
  840. echo 'After=network.target' >> $TRACKER_DAEMON
  841. echo '[Service]' >> $TRACKER_DAEMON
  842. echo 'Type=simple' >> $TRACKER_DAEMON
  843. echo 'User=tracker' >> $TRACKER_DAEMON
  844. echo 'Group=tracker' >> $TRACKER_DAEMON
  845. echo 'WorkingDirectory=/opt/tracker' >> $TRACKER_DAEMON
  846. echo "ExecStart=/usr/bin/bttrack --port $TRACKER_PORT --dfile /opt/tracker/dstate --logfile /opt/tracker/tracker.log --nat_check 0 --scrape_allowed full --ipv6_enabled 0" >> $TRACKER_DAEMON
  847. echo '' >> $TRACKER_DAEMON
  848. echo 'TimeoutSec=300' >> $TRACKER_DAEMON
  849. echo '' >> $TRACKER_DAEMON
  850. echo '[Install]' >> $TRACKER_DAEMON
  851. echo 'WantedBy=multi-user.target' >> $TRACKER_DAEMON
  852. chroot "$rootdir" useradd -d /opt/tracker/ -s /bin/false tracker
  853. if [ ! -d $rootdir/opt/tracker ]; then
  854. mkdir $rootdir/opt/tracker
  855. fi
  856. chroot "$rootdir" chown -R tracker:tracker /opt/tracker
  857. # publish regularly
  858. echo "* * * * * root zeronetavahi > /dev/null" >> $rootdir/etc/crontab
  859. chroot "$rootdir" systemctl enable tracker.service
  860. chroot "$rootdir" systemctl enable zeronet.service
  861. }
  862. initialise_mesh() {
  863. if [[ $VARIANT != "mesh" && $VARIANT != "meshclient" && $VARIANT != "meshusb" ]]; then
  864. return
  865. fi
  866. if [[ $DEBIAN_INSTALL_ONLY != "no" ]]; then
  867. return
  868. fi
  869. if [[ $INSECURE == $'yes' ]]; then
  870. echo '*********************************************************'
  871. echo $'WARNING: non-free wifi drivers are being installed.'
  872. echo $' This may compromise the security of your system.'
  873. echo '*********************************************************'
  874. # enable non-free repo
  875. if ! grep -q "non-free" $rootdir/etc/apt/sources.list; then
  876. chroot "$rootdir" sed -i "s| main| main non-free|g" /etc/apt/sources.list
  877. chroot "$rootdir" apt-get update
  878. fi
  879. # install proprietary wifi drivers
  880. # see https://wiki.debian.org/iwlwifi
  881. chroot "$rootdir" apt-get -y install firmware-iwlwifi
  882. fi
  883. mesh_firewall
  884. mesh_avahi
  885. mesh_batman
  886. mesh_tox_node
  887. mesh_tox_avahi
  888. mesh_tox_client
  889. mesh_zeronet
  890. MESH_SERVICE='mesh-setup.service'
  891. MESH_SETUP_DAEMON=$rootdir/etc/systemd/system/$MESH_SERVICE
  892. echo '[Unit]' > $MESH_SETUP_DAEMON
  893. echo 'Description=Initial mesh router configuration' >> $MESH_SETUP_DAEMON
  894. echo 'After=syslog.target' >> $MESH_SETUP_DAEMON
  895. echo 'After=network.target' >> $MESH_SETUP_DAEMON
  896. echo '[Service]' >> $MESH_SETUP_DAEMON
  897. echo 'Type=simple' >> $MESH_SETUP_DAEMON
  898. echo 'User=root' >> $MESH_SETUP_DAEMON
  899. echo 'Group=root' >> $MESH_SETUP_DAEMON
  900. echo 'WorkingDirectory=/root' >> $MESH_SETUP_DAEMON
  901. echo "ExecStart=/usr/local/bin/${PROJECT_NAME}-image-mesh > /var/log/mesh-setup.log" >> $MESH_SETUP_DAEMON
  902. echo '' >> $MESH_SETUP_DAEMON
  903. echo 'TimeoutSec=99999' >> $MESH_SETUP_DAEMON
  904. echo '' >> $MESH_SETUP_DAEMON
  905. echo '[Install]' >> $MESH_SETUP_DAEMON
  906. echo 'WantedBy=multi-user.target' >> $MESH_SETUP_DAEMON
  907. chroot "$rootdir" systemctl enable $MESH_SERVICE
  908. }
  909. # User interface for USB drive installs ######################################
  910. function enable_tox_repo {
  911. echo 'deb http://download.opensuse.org/repositories/home:/antonbatenev:/tox/Debian_8.0/ /' > $rootdir/etc/apt/sources.list.d/tox.list
  912. chroot "$rootdir" wget -q http://download.opensuse.org/repositories/home:antonbatenev:tox/Debian_8.0/Release.key -O- | apt-key add -
  913. chroot "$rootdir" apt-get update
  914. echo "Tox Repository Installed."
  915. }
  916. function install_syncthing {
  917. if [[ $SYSTEM_TYPE == "$VARIANT_WRITER" || $SYSTEM_TYPE == "$VARIANT_MAILBOX" || $SYSTEM_TYPE == "$VARIANT_CHAT" || $SYSTEM_TYPE == "$VARIANT_SOCIAL" || $SYSTEM_TYPE == "$VARIANT_MEDIA" || $SYSTEM_TYPE == "$VARIANT_DEVELOPER" ]]; then
  918. return
  919. fi
  920. chroot "$rootdir" wget -q https://syncthing.net/release-key.txt -O- | apt-key add -
  921. echo "deb http://apt.syncthing.net/ syncthing release" | tee $rootdir/etc/apt/sources.list.d/syncthing.list
  922. chroot "$rootdir" apt-get update
  923. chroot "$rootdir" apt-get -y --force-yes install syncthing
  924. # This probably does need to run as root so that it can access the Sync directories
  925. # in each user's home directory
  926. chroot "$rootdir" echo '[Unit]' > /etc/systemd/system/syncthing.service
  927. chroot "$rootdir" echo 'Description=Syncthing - Open Source Continuous File Synchronization' >> /etc/systemd/system/syncthing.service
  928. chroot "$rootdir" echo 'Documentation=man:syncthing(1)' >> /etc/systemd/system/syncthing.service
  929. chroot "$rootdir" echo 'After=network.target' >> /etc/systemd/system/syncthing.service
  930. chroot "$rootdir" echo 'Wants=syncthing-inotify@.service' >> /etc/systemd/system/syncthing.service
  931. chroot "$rootdir" echo '' >> /etc/systemd/system/syncthing.service
  932. chroot "$rootdir" echo '[Service]' >> /etc/systemd/system/syncthing.service
  933. chroot "$rootdir" echo 'User=root' >> /etc/systemd/system/syncthing.service
  934. chroot "$rootdir" echo "Environment='all_proxy=socks5://localhost:9050'" >> /etc/systemd/system/syncthing.service
  935. chroot "$rootdir" echo 'ExecStart=/usr/bin/syncthing -no-browser -no-restart -logflags=0' >> /etc/systemd/system/syncthing.service
  936. chroot "$rootdir" echo 'Restart=on-failure' >> /etc/systemd/system/syncthing.service
  937. chroot "$rootdir" echo 'SuccessExitStatus=3 4' >> /etc/systemd/system/syncthing.service
  938. chroot "$rootdir" echo 'RestartForceExitStatus=3 4' >> /etc/systemd/system/syncthing.service
  939. chroot "$rootdir" echo '' >> /etc/systemd/system/syncthing.service
  940. chroot "$rootdir" echo '[Install]' >> /etc/systemd/system/syncthing.service
  941. chroot "$rootdir" echo 'WantedBy=multi-user.target' >> /etc/systemd/system/syncthing.service
  942. chroot "$rootdir" systemctl enable syncthing
  943. chroot "$rootdir" systemctl daemon-reload
  944. if ! grep -q "syncthing" $rootdir/etc/crontab; then
  945. chroot "$rootdir" echo "*/1 * * * * root /usr/local/bin/freedombone-syncthing > /dev/null" >> /etc/crontab
  946. chroot "$rootdir" systemctl restart cron
  947. fi
  948. echo 'install_syncthing'
  949. }
  950. function mesh_client_startup_applications {
  951. if [ ! -d $rootdir/home/$MY_USERNAME/Desktop ]; then
  952. mkdir -p $rootdir/home/$MY_USERNAME/Desktop
  953. fi
  954. if [ ! -d $rootdir/home/$MY_USERNAME/.config/autostart ]; then
  955. mkdir -p $rootdir/home/$MY_USERNAME/.config/autostart
  956. fi
  957. echo '[Desktop Entry]' > $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  958. echo 'Name=Tox Chat' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  959. echo 'Type=Application' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  960. echo 'Comment=Chat, VoIP, Video' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  961. echo 'TryExec=qtox' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  962. echo 'Exec=qtox' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  963. echo 'Icon=qtox' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  964. echo 'StartupNotify=true' >> $rootdir/home/$MY_USERNAME/Desktop/tox.desktop
  965. cp $rootdir/home/$MY_USERNAME/Desktop/tox.desktop $rootdir/home/$MY_USERNAME/.config/autostart/tox.desktop
  966. chroot "$rootdir" chown -R $MY_USERNAME:$MY_USERNAME /home/$MY_USERNAME/.config
  967. }
  968. function mesh_desktop_icons {
  969. if [ ! -d $rootdir/home/$MY_USERNAME/Desktop ]; then
  970. mkdir -p $rootdir/home/$MY_USERNAME/Desktop
  971. fi
  972. # Terminal
  973. echo '[Desktop Entry]' > $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  974. echo 'Name=MATE Terminal' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  975. echo 'Type=Application' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  976. echo 'Comment=Use the command line' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  977. echo 'TryExec=mate-terminal' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  978. echo 'Exec=mate-terminal' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  979. echo 'Icon=mate-terminal' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  980. echo 'StartupNotify=true' >> $rootdir/home/$MY_USERNAME/Desktop/terminal.desktop
  981. chroot "$rootdir" chown -R $MY_USERNAME:$MY_USERNAME /home/$MY_USERNAME/Desktop
  982. }
  983. function configure_user_interface {
  984. if [[ $VARIANT != "meshclient" && $VARIANT != "meshusb" && $VARIANT != "usb" ]]; then
  985. return
  986. fi
  987. # desktop
  988. chroot "$rootdir" apt-get -y install mate-desktop-environment
  989. if [[ $VARIANT != "usb" ]]; then
  990. # log in automatically
  991. chroot "$rootdir" apt-get -y install nodm xinit
  992. echo 'NODM_ENABLED=true' > /etc/default/nodm
  993. echo "NODM_USER=$MY_USERNAME" >> /etc/default/nodm
  994. chroot "$rootdir" mkdir /etc/systemd/system/getty@tty1.service.d
  995. echo '[Service]' > $rootdir/etc/systemd/system/getty@tty1.service.d/override.conf
  996. echo 'ExecStart=' >> $rootdir/etc/systemd/system/getty@tty1.service.d/override.conf
  997. echo 'ExecStart=-/sbin/agetty --autologin fbone --noclear %I $TERM' >> $rootdir/etc/systemd/system/getty@tty1.service.d/override.conf
  998. echo '[[ -z $DISPLAY && $XDG_VTNR -eq 1 ]] && exec startx' >> $rootdir/home/$MY_USERNAME/.profile
  999. chroot "$rootdir" systemctl set-default multi-user.target
  1000. mesh_client_startup_applications
  1001. mesh_desktop_icons
  1002. # change the desktop background
  1003. if [ $MESH_DESKTOP_BACKGROUND_IMAGE ]; then
  1004. if [ -f $MESH_DESKTOP_BACKGROUND_IMAGE ]; then
  1005. if [ -d $rootdir/usr/share/images/desktop-base ]; then
  1006. cp $MESH_DESKTOP_BACKGROUND_IMAGE $rootdir/usr/share/images/desktop-base/${PROJECT_NAME}_mesh_background.png
  1007. chroot "$rootdir" rm /usr/share/images/desktop-base/desktop-background
  1008. chroot "$rootdir" ln -s /usr/share/images/desktop-base/${PROJECT_NAME}_mesh_background.png /usr/share/images/desktop-base/desktop-background
  1009. fi
  1010. fi
  1011. fi
  1012. else
  1013. chroot "$rootdir" apt-get -y install lightdm
  1014. fi
  1015. # browser
  1016. chroot "$rootdir" apt-get -y install iceweasel
  1017. # NOTE: The Tox repo only supports a limited range of architectures
  1018. if [[ $ARCHITECTURE == 'amd64' || $ARCHITECTURE == 'i386' ]]; then
  1019. # Tox user interface
  1020. enable_tox_repo
  1021. # TODO: this may not work on all architectures
  1022. chroot "$rootdir" apt-get -y --force-yes install qtox
  1023. fi
  1024. # Syncthing
  1025. install_syncthing
  1026. if [[ $VARIANT == "usb" ]]; then
  1027. # tor
  1028. chroot "$rootdir" apt-get -y install tor
  1029. # xmpp client
  1030. chroot "$rootdir" echo "deb ftp://ftp.gajim.org/debian unstable main" > /etc/apt/sources.list.d/gajim.list
  1031. chroot "$rootdir" apt-get update
  1032. chroot "$rootdir" apt-get -y install gajim-dev-keyring
  1033. chroot "$rootdir" apt-get -y install git python-dev python-pip gajim-nightly
  1034. chroot "$rootdir" mkdir /home/$GENERIC_IMAGE_USERNAME/.local/share/gajim/plugins -p
  1035. chroot "$rootdir" git clone https://github.com/omemo/gajim-omemo /home/$GENERIC_IMAGE_USERNAME/.local/share/gajim/plugins/gajim-omemo
  1036. chroot "$rootdir" pip install protobuf==2.6.1, python-axolotl==0.1.35
  1037. chroot "$rootdir" chown -R $GENERIC_IMAGE_USERNAME:$GENERIC_IMAGE_USERNAME /home/$GENERIC_IMAGE_USERNAME/.local
  1038. # IRC client
  1039. chroot "$rootdir" apt-get -y install hexchat profanity
  1040. # zeronet
  1041. # TODO
  1042. fi
  1043. }
  1044. ##############################################################################
  1045. # Set to true/false to control if eatmydata is used during build
  1046. use_eatmydata=true
  1047. rootdir="$1"
  1048. fmdir="$(pwd)"
  1049. image="$fmdir"/"$2"
  1050. cd "$rootdir"
  1051. echo info: building $MACHINE for $ARCHITECTURE
  1052. export DEBIAN_FRONTEND=noninteractive DEBCONF_NONINTERACTIVE_SEEN=true
  1053. export LC_ALL=C LANGUAGE=C LANG=C
  1054. # Override libpam-tmpdir setting during build, as the directories
  1055. # are not created yet.
  1056. export TMP=/tmp/ TMPDIR=/tmp/
  1057. username=$MY_USERNAME
  1058. echo $"warning: creating initial user $username with well known password!"
  1059. password=$MY_PASSWORD
  1060. chroot "$rootdir" adduser --gecos $username --disabled-password $username
  1061. if [[ $VARIANT != "meshclient" && $VARIANT != "meshusb" ]]; then
  1062. echo $username:$password | chroot $rootdir /usr/sbin/chpasswd
  1063. fi
  1064. chroot "$rootdir" adduser $username sudo
  1065. case "$MACHINE" in
  1066. virtualbox)
  1067. # hide irrelevant console keyboard messages.
  1068. echo "echo \"4 4 1 7\" > /proc/sys/kernel/printk" \
  1069. >> /etc/init.d/rc.local
  1070. ;;
  1071. qemu)
  1072. # hide irrelevant console keyboard messages.
  1073. echo "echo \"4 4 1 7\" > /proc/sys/kernel/printk" \
  1074. >> /etc/init.d/rc.local
  1075. ;;
  1076. esac
  1077. set_apt_sources $BUILD_MIRROR
  1078. chroot "$rootdir" apt-get clean
  1079. chroot "$rootdir" rm -rf /var/lib/apt/lists/*
  1080. chroot "$rootdir" apt-get clean
  1081. chroot "$rootdir" apt-get update
  1082. cat > $rootdir/usr/sbin/policy-rc.d <<EOF
  1083. #!/bin/sh
  1084. exit 101
  1085. EOF
  1086. chmod a+rx $rootdir/usr/sbin/policy-rc.d
  1087. if $use_eatmydata ; then
  1088. enable_eatmydata_override
  1089. fi
  1090. if [ -n "$CUSTOM_SETUP" ]; then
  1091. cp "$CUSTOM_SETUP" "$rootdir"/tmp
  1092. chroot "$rootdir" apt-get install -y gdebi-core
  1093. chroot "$rootdir" gdebi -n /tmp/"$(basename $CUSTOM_SETUP)"
  1094. fi
  1095. chroot "$rootdir" apt-get install -y sudo git dialog toilet build-essential openssh-server
  1096. chroot "$rootdir" apt-get install -y avahi-daemon avahi-utils avahi-discover avahi-autoipd
  1097. chroot "$rootdir" apt-get install -y iptables dnsutils net-tools network-manager iputils-ping
  1098. chroot "$rootdir" apt-get install -y libnss-mdns libnss-myhostname libnss-gw-name nano man ntp
  1099. chroot "$rootdir" apt-get install -y locales locales-all debconf wireless-tools wpasupplicant
  1100. sed -i "s|#host-name=.*|host-name=${PROJECT_NAME}|g" $rootdir/etc/avahi/avahi-daemon.conf
  1101. sed -i "s|host-name=.*|host-name=${PROJECT_NAME}|g" $rootdir/etc/avahi/avahi-daemon.conf
  1102. chroot "$rootdir" /bin/bash -x <<EOF
  1103. git clone $PROJECT_REPO /root/$PROJECT_NAME
  1104. cd /root/$PROJECT_NAME
  1105. make install
  1106. EOF
  1107. chroot "$rootdir" ${PROJECT_NAME}-image-hardware-setup 2>&1 | \
  1108. tee $rootdir/var/log/${PROJECT_NAME}-image-hardware-setup.log
  1109. rm $rootdir/usr/sbin/policy-rc.d
  1110. # Set up HRNG for systems known to have one
  1111. # Otherwise install haveged
  1112. if [[ "$MACHINE" != "beaglebone" ]]; then
  1113. chroot $rootdir apt-get -y install haveged
  1114. else
  1115. chroot $rootdir apt-get -y install rng-tools
  1116. sed -i 's|#HRNGDEVICE=/dev/hwrng|HRNGDEVICE=/dev/hwrng|g' $rootdir/etc/default/rng-tools
  1117. fi
  1118. # copy u-boot to beginning of image
  1119. case "$MACHINE" in
  1120. beaglebone)
  1121. dd if=$rootdir/usr/lib/u-boot/am335x_boneblack/MLO of="$image" \
  1122. count=1 seek=1 conv=notrunc bs=128k
  1123. dd if=$rootdir/usr/lib/u-boot/am335x_boneblack/u-boot.img of="$image" \
  1124. count=2 seek=1 conv=notrunc bs=384k
  1125. ;;
  1126. cubieboard2)
  1127. dd if=$rootdir/usr/lib/u-boot/Cubieboard2/u-boot-sunxi-with-spl.bin of="$image" \
  1128. seek=8 conv=notrunc bs=1k
  1129. ;;
  1130. a20-olinuxino-lime)
  1131. dd if=$rootdir/usr/lib/u-boot/A20-OLinuXino-Lime/u-boot-sunxi-with-spl.bin \
  1132. of="$image" seek=8 conv=notrunc bs=1k
  1133. ;;
  1134. esac
  1135. if $use_eatmydata ; then
  1136. disable_eatmydata_override
  1137. fi
  1138. set_apt_sources $MIRROR
  1139. chroot "$rootdir" apt-get update
  1140. configure_ssh
  1141. configure_networking
  1142. admin_user_sudo
  1143. create_generic_image
  1144. atheros_wifi
  1145. continue_installation
  1146. initialise_mesh
  1147. configure_wifi
  1148. configure_user_interface
  1149. cd /
  1150. echo $"info: killing leftover processes in chroot"
  1151. fuser -mvk $rootdir/. || true
  1152. exit 0